#define COPY_BUTTON  'cpb'
#define CLEAR_BUTTON 'clb'
#define CONV_BUTTON  'cvb'

//==========================================================
//                     MAIN WINDOW
//========================================================== 
class Appwindow	:	public BWindow
{
	private:
				char		 *s,*tmp;
				int			 length,a,val;
				BBox    	 *top,*willconvbox,*convertedbox;
				BButton 	 *butcopy,*butclear,*butconv;
				BRadioButton *smallx,*bigx,*randx,*radiobe;
				BTextView	 *willconvtext,*convertedtext;
	public:
				void checkthex();
					 Appwindow(BRect frame);
		virtual void MessageReceived(BMessage *inmsg);					 					 
		virtual	bool QuitRequested();
};

//==========================================================
//                      REQUESTED QUIT
//========================================================== 
bool Appwindow::QuitRequested()
{
	be_app->PostMessage(B_QUIT_REQUESTED);
	return true;
};

//==========================================================
//                      GOT ANY MESSAGES?
//========================================================== 
void Appwindow::MessageReceived(BMessage *inmsg)
{
	switch(inmsg->what)
	{
		case CONV_BUTTON:
		{
			strcpy(s,"");
			tmp=(char*)willconvtext->Text();
			length=strlen(tmp);
			checkthex();
			
			for(a=0; a<length; a++)
			{
				if(tmp[a]==' ' && tmp[a+1]!=' ')
				{
					strcat(s," ");
					checkthex();
				}
				else strncat(s,tmp+a,1);
			}
			
			convertedtext->SetText(s);
			break;
		}
		
		case COPY_BUTTON:
		{
			convertedtext->SelectAll();
			convertedtext->Copy(be_clipboard);
			break;
		}
		
		case CLEAR_BUTTON:
		{
			willconvtext->SetText("");
			convertedtext->SetText("");
			break;
		}
	}
};

//==========================================================
//            WHAT TYPE OF CONVERSION IS REQUESTED?
//========================================================== 
void Appwindow::checkthex()
{
	if(smallx->Value()) strcat(s,"x");
	if(bigx->Value()==1)   strcat(s,"X");
	if(randx->Value()==1)
	{
		if(rand()%2==1) strcat(s,"x");
		else			strcat(s,"X");
	}
	if(radiobe->Value()) strcat(s,"Be");
};